package com.logicbig.example;

import org.springframework.context.annotation.AnnotationConfigApplicationContext;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.FilterType;
import org.springframework.stereotype.Component;
import org.springframework.stereotype.Service;

@Configuration
@ComponentScan(useDefaultFilters = false,
        includeFilters = @ComponentScan.Filter(type = FilterType.REGEX, pattern = "ConstructorDiExample"))
public class ConstructorDiExample {

    public static void main(String[] args) {
        AnnotationConfigApplicationContext context =
                new AnnotationConfigApplicationContext(ConstructorDiExample.class);
        ClientBean bean = context.getBean(ClientBean.class);
        bean.doSomething();
    }

    @Component
    private static class ClientBean {
        private final ServiceBean serviceBean;

        private ClientBean(ServiceBean serviceBean) {
            this.serviceBean = serviceBean;
        }

        void doSomething() {
            System.out.println("doing something with: " + serviceBean);
        }
    }

    //uncomment @service to get rid of UnsatisfiedDependencyException
   // @Service
    private class ServiceBean {

    }
}